package com.romhay.chatter_sms

import io.flutter.plugin.common.JSONMethodCodec
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry
import io.flutter.plugin.common.StandardMethodCodec

/** ChatterSmsPlugin */
class ChatterSmsPlugin {

    companion object {
        private const val querySMS = "chatter.romhay.app/querySMS"
        private const val queryContact = "chatter.romhay.app/queryContact"
        private const val queryContactPhoto = "chatter.romhay.app/queryContactPhoto"
        private const val queryUserProfile = "chatter.romhay.app/userProfile"

        @JvmStatic
        fun registerWith(registrar: PluginRegistry.Registrar) {
            val querySmsChannel = MethodChannel(registrar.messenger(), querySMS, JSONMethodCodec.INSTANCE)
            querySmsChannel.setMethodCallHandler(SMSQuery(registrar))

            val queryContactChannel = MethodChannel(registrar.messenger(), queryContact, JSONMethodCodec.INSTANCE)
            queryContactChannel.setMethodCallHandler(ContactQuery(registrar))

            val queryContactPhotoChannel = MethodChannel(registrar.messenger(), queryContactPhoto, StandardMethodCodec.INSTANCE)
            queryContactPhotoChannel.setMethodCallHandler(ContactPhotoQuery(registrar))

            val userProfileProviderChannel = MethodChannel(registrar.messenger(), queryUserProfile, JSONMethodCodec.INSTANCE)
            userProfileProviderChannel.setMethodCallHandler(UserProfileProvider(registrar))
        }
    }

}